package ReadTags;

import RFIDReader.OnTagReadResponse;
import RFIDReader.RFIDReader;
import RFIDReader.TagReadInfo;

/*
 * The following code is an example of how to read tags using the connected reader.
 * To run the code successfully the IP Address must be changed to match that of the
 * reader for intended use.
 */

public class ReadingTags {
	
	static final String DEFAULT_READER_IP_ADDRESS = "192.168.1.120";
	static final int PORT_NUMBER = 5000;
	static final int maxResponseSize = 1000;
	static RFIDReader reader = null;
	public static boolean reading = false;
	
	public static void main(String[] args){
		try
		{
			String readerIPAddress = DEFAULT_READER_IP_ADDRESS;
			int PortNumber = PORT_NUMBER;

			System.out.println("Setting up ReaderComm instance on IP Address " + readerIPAddress);
			
			reader = new RFIDReader(readerIPAddress, PortNumber);
			
			ReaderInfo();
			ReadTest();
			
			

		}
		catch (Exception ex)
		{
			System.out.println("Main: " + ex.toString());
		}
	}
	
	
	public static void ReadTest() throws Exception, InterruptedException
	{
		TagReadHandler tagReadHandler = new TagReadHandler();
		ReadingTags.reader.SetTagReadCallback(tagReadHandler);
		System.out.println("Starting Continuous Read ...");
		ReadingTags.reading = true;
		ReadingTags.reader.StartContinuousRead();
		
		// Read for 20 seconds then issue stop command
		Thread.sleep(20000);
		
		System.out.println("Stopping Continuous Read ...");
		ReadingTags.reader.StopContinuousRead();
		
		
		//While loop to read queued up
		//tag data and to wait for stop command response.
		
		
		while(ReadingTags.reading)
		{	
			Thread.sleep(10);
		} 
	}
	
	public static void ReaderInfo() throws Exception {
		String id = "";
				
		id = ReadingTags.reader.GetHardwareId();
		System.out.println("SensArray Hardware Id: " + id);
	}	

}

class TagReadHandler implements OnTagReadResponse
{
	public void handleTagRead(TagReadInfo readInfo)
	{
		if (readInfo.tagReadStatus == TagReadInfo.OK)
			System.out.println(readInfo.EPC);
		else if (readInfo.tagReadStatus == TagReadInfo.DONE)
		{
			ReadingTags.reading = false;
			System.out.println("Received Stop Response");
		}
	}
}
